#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN=2e5+5;
const int MAXQ=2e5+5;

struct Fenwick
{
    int tree[MAXN];
    int n;

    void init(int _n)
    {
        n=_n;
        fill(tree+1,tree+n+1,0);
    }

    void update(int idx,int val)
    {
        for(; idx<=n; idx+=idx&(-idx))
        {
            tree[idx]+=val;
        }
    }

    int query(int idx)
    {
        int ret=0;
        for(; idx>0; idx-=idx&(-idx))
        {
            ret+=tree[idx];
        }
        return ret;
    }

    int query(int l,int r)
    {
        return query(r)-query(l-1);
    }
};

struct Query
{
    int type;
    int x,y;
    int val;
    int num;
};

int n,m;
int a[MAXN];
int b[MAXN];
int pos[MAXN];
Fenwick tree;
vector<Query> qr;
vector<Query> tmp;
int ans[MAXQ];

void cdq(int l,int r)
{
    if(l>=r) return;

    int mid=(l+r)/2;
    cdq(l,mid);
    cdq(mid+1,r);

    int ptrL=l;
    for(int i=mid+1; i<=r; i++)
    {
        while(ptrL<=mid && qr[ptrL].x<=qr[i].x)
        {
            if(qr[ptrL].type==1) tree.update(qr[ptrL].y,qr[ptrL].val);
            tmp.push_back(qr[ptrL]);
            ptrL++;
        }
        if(qr[i].type==2) ans[qr[i].num]+=tree.query(qr[i].y)*qr[i].val;
        tmp.push_back(qr[i]);
    }
    for(int i=ptrL; i<=mid; i++) tmp.push_back(qr[i]);

    for(int i=l; i<ptrL; i++) if(qr[i].type==1) tree.update(qr[i].y, -qr[i].val);

    for(int i=l; i<=r; i++) qr[i]=tmp[i-l];
    tmp.clear();
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin>>n>>m;
    tree.init(n);
    for(int i=1; i<=n; i++)
    {
        cin>>a[i];
        pos[a[i]]=i;
    }
    for(int i=1; i<=n; i++)
    {
        cin>>b[i];
    }

    for(int i=1; i<=n; i++)
    {
        qr.push_back({1,pos[b[i]],i,1,0});
    }

    int ptr=1;
    for(int i=0; i<m; i++)
    {
        int type;
        cin>>type;
        if(type==1)
        {
            int la,ra,lb,rb;
            cin>>la>>ra>>lb>>rb;
            qr.push_back({2,ra,rb,1,ptr});
            qr.push_back({2,ra,lb-1,-1,ptr});
            qr.push_back({2,la-1,rb,-1,ptr});
            qr.push_back({2,la-1,lb-1,1,ptr});
            ptr++;
        }
        else
        {
            int x,y;
            cin>>x>>y;
            qr.push_back({1,pos[b[x]],x,-1,0});
            qr.push_back({1,pos[b[y]],y,-1,0});
            swap(b[x], b[y]);
            qr.push_back({1,pos[b[x]],x,1,0});
            qr.push_back({1,pos[b[y]],y,1,0});
        }
    }

    tmp.reserve(qr.size()+5);
    cdq(0,qr.size()-1);

    for(int i=1; i<ptr; i++) cout<<ans[i]<<endl;

    return 0;
}
