#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN=5e5+5;
const int MAXVAL=1e6+5;

struct Fenwick
{
    int tree[MAXVAL];
    int n;

    void init(int _n)
    {
        n=_n;
        fill(tree+1,tree+n+1,0);
    }

    void update(int idx,int val)
    {
        for(; idx<=n; idx+=idx&(-idx))
        {
            tree[idx]+=val;
        }
    }

    int query(int idx)
    {
        int ret=0;
        for(; idx>0; idx-=idx&(-idx))
        {
            ret+=tree[idx];
        }
        return ret;
    }

    int query(int l,int r)
    {
        return query(r)-query(l-1);
    }
};

struct Query
{
    int type;
    int l,r;
    int num;
};

int n;
int comp[2*MAXN];
unordered_map<int,int> code;
int mx;
Fenwick tree;
Query qr[MAXN];
vector<Query> tmp;
int ans[MAXN];

void compress()
{
    int ptr=1;
    for(int i=1; i<=n; i++)
    {
        comp[ptr++]=qr[i].l;
        comp[ptr++]=qr[i].r;
    }
    sort(comp+1,comp+ptr);

    mx=0;
    for(int i=1; i<ptr; i++)
    {
        if(comp[i]!=comp[i-1]) code[comp[i]]=++mx;
    }

    for(int i=1; i<=n; i++)
    {
        qr[i].l=code[qr[i].l];
        qr[i].r=code[qr[i].r];
    }
}

void cdq(int l,int r)
{
    if(l>=r) return;

    int mid=(l+r)/2;
    cdq(l,mid);
    cdq(mid+1,r);

    int ptrL=l;
    for(int i=mid+1; i<=r; i++)
    {
        while(ptrL<=mid && qr[ptrL].l<=qr[i].l)
        {
            if(qr[ptrL].type==1) tree.update(qr[ptrL].r,1);
            tmp.push_back(qr[ptrL]);
            ptrL++;
        }
        if(qr[i].type==2) ans[qr[i].num]+=tree.query(qr[i].r,mx);
        tmp.push_back(qr[i]);
    }
    for(int i=ptrL; i<=mid; i++) tmp.push_back(qr[i]);

    for(int i=l; i<ptrL; i++) if(qr[i].type==1) tree.update(qr[i].r,-1);

    for(int i=l; i<=r; i++) qr[i]=tmp[i-l];
    tmp.clear();
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin>>n;
    int ptr=1;
    for(int i=1; i<=n; i++)
    {
        char type;
        cin>>type>>qr[i].l>>qr[i].r;
        if(type=='+') qr[i].type=1;
        else
        {
            qr[i].type=2;
            qr[i].num=ptr++;
        }
    }

    compress();

    tree.init(mx);
    tmp.reserve(n+5);
    cdq(1,n);

    for(int i=1; i<ptr; i++) cout<<ans[i]<<endl;

    return 0;
}
