#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN=1e5+5;

int n;

struct Fenwick
{
    int tree[MAXN];

    void init()
    {
        fill(tree+1,tree+n+1,0);
    }

    void update(int idx,int val)
    {
        for(; idx<=n; idx+=idx&(-idx))
        {
            tree[idx]+=val;
        }
    }

    int query(int idx)
    {
        int ret=0;
        for(; idx>0; idx-=idx&(-idx))
        {
            ret+=tree[idx];
        }
        return ret;
    }

    int query(int l,int r)
    {
        return query(r)-query(l-1);
    }
};

struct Point
{
    int x,y,z;
    int num;
};

Point p[MAXN];
Fenwick tree;
int ans[MAXN];
vector<Point> tmp;

void cdq(int l,int r)
{
    if(l==r) return;

    int mid=(l+r)/2;
    cdq(l,mid);
    cdq(mid+1,r);

    int ptrL=l;
    for(int i=mid+1; i<=r; i++)
    {
        while(ptrL<=mid && p[ptrL].y>p[i].y)
        {
            tree.update(p[ptrL].z,1);
            tmp.push_back(p[ptrL]);
            ptrL++;
        }
        ans[p[i].num]+=tree.query(p[i].z+1,n);
        tmp.push_back(p[i]);
    }
    for(int i=ptrL; i<=mid; i++) tmp.push_back(p[i]);

    for(int i=l; i<ptrL; i++) tree.update(p[i].z,-1);

    for(int i=l; i<=r; i++) p[i]=tmp[i-l];
    tmp.clear();
}

bool cmp(Point a,Point b)
{
    if(a.x==b.x)
    {
        if(a.y==b.y) return a.z<b.z;
        return a.y<b.y;
    }
    return a.x>b.x;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin>>n;
    for(int i=1; i<=n; i++)
    {
        cin>>p[i].x>>p[i].y>>p[i].z;
        p[i].num=i;
    }

    sort(p+1,p+n+1,cmp);

    tree.init();
    tmp.reserve(n+5);

    cdq(1,n);

    for(int i=1; i<=n; i++) cout<<ans[i]<<endl;

    return 0;
}
