#include<bits/stdc++.h>
#define endl '\n'
#define fi first
#define se second

using namespace std;

const int MAXN=1e5+5;
const int MAXQ=7e4+5;

struct Query
{
    int type;
    int x,y;
    int id,sgn;
    Query() {};
    Query(int _type,int _x,int _y,int _id,int _sgn)
    {
        type=_type;
        x=_x;
        y=_y;
        id=_id;
        sgn=_sgn;
    }
};

int n,q;
vector<int> adj[2][2*MAXN];
pair<int,int> qrs[MAXQ];
int timer;
int tin[2][2*MAXN];
int tout[2][2*MAXN];
int cntV;
vector<Query> qr;
int ans[MAXQ];
int tree[2*MAXN];
vector<Query> tmp;
vector<pair<int,int> > hist;

void dfs(int v,int par,int t)
{
    tin[t][v]=++timer;
    for(auto u: adj[t][v])
    {
        if(u==par) continue;
        dfs(u,v,t);
    }
    tout[t][v]=timer;
}

void update(int ind,int val)
{
    while(ind<=cntV)
    {
        tree[ind]+=val;
        ind+=ind&(-ind);
    }
}

int query(int ind)
{
    int ret=0;
    while(ind>0)
    {
        ret+=tree[ind];
        ind-=ind&(-ind);
    }
    return ret;
}

int query(int l,int r)
{
    return query(r)-query(l-1);
}

void cdq(int l,int r)
{
    if(l==r) return;

    int mid=(l+r)/2;
    cdq(l,mid);
    cdq(mid+1,r);

    int a=l,b=mid+1;
    while(a<=mid && b<=r)
    {
        if(qr[a].x>=qr[b].x)
        {
            if(qr[a].type==1)
            {
                update(qr[a].y,1);
                hist.push_back({qr[a].y,-1});
            }
            tmp.push_back(qr[a++]);
        }
        else
        {
            if(qr[b].type==2)
            {
                ans[qr[b].id]-=qr[b].sgn*query(qr[b].y,cntV);
            }
            tmp.push_back(qr[b++]);
        }
    }
    for(; a<=mid; a++) tmp.push_back(qr[a]);
    for(; b<=r; b++)
    {
        if(qr[b].type==2)
        {
            ans[qr[b].id]-=qr[b].sgn*query(qr[b].y,cntV);
        }
        tmp.push_back(qr[b]);
    }

    for(int i=l; i<=r; i++) qr[i]=tmp[i-l];
    for(auto [pos,val]: hist) update(pos,val);

    tmp.clear();
    hist.clear();
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    //freopen("company.in","r",stdin);
    //freopen("company.out","w",stdout);

    cin>>n;
    for(int t=0; t<2; t++)
    {
        for(int i=2; i<=n; i++)
        {
            int v;
            cin>>v;
            adj[t][v].push_back(i);
        }
    }

    cin>>q;
    for(int i=0; i<q; i++)
    {
        cin>>qrs[i].fi>>qrs[i].se;
        if(qrs[i].fi==1)
        {
            int v1,v2;
            cin>>v1>>v2;
            adj[0][v1].push_back(qrs[i].se);
            adj[1][v2].push_back(qrs[i].se);
        }
    }

    timer=0;
    dfs(1,-1,0);
    cntV=timer;
    timer=0;
    dfs(1,-1,1);

    for(int i=1; i<=n; i++) update(tin[0][i],1);
    int ptr=0;
    for(int i=0; i<q; i++)
    {
        if(qrs[i].fi==1) update(tin[0][qrs[i].se],1);
        else ans[ptr++]=query(tin[0][qrs[i].se],tout[0][qrs[i].se]);
    }
    for(int i=1; i<=n; i++) update(tin[0][i],-1);
    for(int i=0; i<q; i++)
        if(qrs[i].fi==1) update(tin[0][qrs[i].se],-1);

    for(int i=1; i<=n; i++)
    {
        qr.push_back(Query(1,tin[0][i],tin[1][i],0,0));
    }
    ptr=0;
    for(int i=0; i<q; i++)
    {
        int v=qrs[i].se;
        if(qrs[i].fi==1) qr.push_back(Query(1,tin[0][v],tin[1][v],0,0));
        else
        {
            qr.push_back(Query(2,tin[0][v],tin[1][v],ptr,1));
            qr.push_back(Query(2,tout[0][v]+1,tin[1][v],ptr,-1));
            qr.push_back(Query(2,tin[0][v],tout[1][v]+1,ptr,-1));
            qr.push_back(Query(2,tout[0][v]+1,tout[1][v]+1,ptr,1));
            ptr++;
        }
    }

    cdq(0,qr.size()-1);

    for(int i=0; i<ptr; i++) cout<<ans[i]<<endl;

    return 0;
}
