#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN=1e5+5;

int n;

struct Fenwick
{
    int tree[MAXN];

    void init()
    {
        fill(tree+1,tree+n+1,0);
    }

    void update(int idx,int val)
    {
        for(; idx<=n; idx+=idx&(-idx))
        {
            tree[idx]+=val;
        }
    }

    int query(int idx)
    {
        int ret=0;
        for(; idx>0; idx-=idx&(-idx))
        {
            ret+=tree[idx];
        }
        return ret;
    }

    int query(int l,int r)
    {
        return query(r)-query(l-1);
    }
};

struct Point
{
    int x,y,z;
};

Fenwick tree;
Point p[MAXN];
int ord[MAXN];
int del[MAXN];
vector<Point> tmp;
long long totalInv;
long long ans[MAXN];

void calcInv()
{
    tree.init();
    totalInv=0;
    for(int i=1; i<=n; i++)
    {
        totalInv+=tree.query(p[i].y+1,n);
        tree.update(p[i].y,1);
    }
}

void cdq(int l,int r)
{
    if(l>=r) return;

    int mid=(l+r)/2;
    cdq(l,mid);
    cdq(mid+1,r);

    int ptrL=l;
    for(int i=mid+1; i<=r; i++)
    {
        while(ptrL<=mid && p[ptrL].y>p[i].y)
        {
            tree.update(p[ptrL].z,1);
            tmp.push_back(p[ptrL]);
            ptrL++;
        }
        ans[p[i].x]+=tree.query(p[i].z+1,n);
        tmp.push_back(p[i]);
    }
    for(int i=ptrL; i<=mid; i++) tmp.push_back(p[i]);

    for(int i=l; i<ptrL; i++) tree.update(p[i].z,-1);

    int ptrR=r;
    for(int i=mid; i>=l; i--)
    {
        while(ptrR>mid && p[ptrR].y<p[i].y)
        {
            tree.update(p[ptrR].z,1);
            ptrR--;
        }
        ans[p[i].x]+=tree.query(p[i].z+1,n);
    }

    for(int i=r; i>ptrR; i--) tree.update(p[i].z,-1);

    for(int i=l; i<=r; i++) p[i]=tmp[i-l];
    tmp.clear();
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin>>n;
    for(int i=1; i<=n; i++)
    {
        p[i].x=i;
        cin>>p[i].y;
        ord[p[i].y]=i;
    }
    for(int i=1; i<=n-2; i++)
    {
        cin>>del[i];
        p[ord[del[i]]].z=i;
    }

    for(int i=1; i<=n; i++)
    {
        if(p[i].z==0) p[i].z=n;
    }

    calcInv();

    tree.init();
    tmp.reserve(n+5);
    cdq(1,n);

    cout<<totalInv<<" ";
    for(int i=1; i<=n-2; i++)
    {
        totalInv-=ans[ord[del[i]]];
        cout<<totalInv<<" ";
    }
    cout<<endl;

    return 0;
}
