#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXVAL=1e5+5;
const int MAXQ=1e5+5;

struct Fenwick
{
    int tree[MAXVAL+1];
    int n;

    void init(int _n)
    {
        n=_n;
        fill(tree+1,tree+n+1,0);
    }

    void update(int idx,int val)
    {
        for(; idx<=n; idx+=idx&(-idx))
        {
            tree[idx]+=val;
        }
    }

    int query(int idx)
    {
        int ret=0;
        for(; idx>0; idx-=idx&(-idx))
        {
            ret+=tree[idx];
        }
        return ret;
    }

    int query(int l,int r)
    {
        return query(r)-query(l-1);
    }
};

struct Query
{
    int type;
    int x;
};

int q;
Query qr[MAXQ];
Fenwick tree;
int ans[MAXQ];

void cdq(int l,int r)
{
    if(l==r) return;

    int mid=(l+r)/2;
    cdq(l,mid);
    cdq(mid+1,r);

    for(int i=l; i<=mid; i++)
    {
        if(qr[i].type==1) tree.update(qr[i].x,1);
    }
    for(int i=mid+1; i<=r; i++)
    {
        if(qr[i].type==2) ans[i]+=tree.query(1,qr[i].x-1);
    }

    for(int i=l; i<=mid; i++)
    {
        if(qr[i].type==1) tree.update(qr[i].x,-1);
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    tree.init(MAXVAL);

    cin>>q;
    for(int i=1; i<=q; i++)
    {
        cin>>qr[i].type>>qr[i].x;
    }

    cdq(1,q);

    for(int i=1; i<=q; i++)
    {
        if(qr[i].type==2) cout<<ans[i]<<endl;
    }

    return 0;
}
