#include<bits/stdc++.h>
#define endl '\n'
#define fi first
#define se second

using namespace std;

const int MAXN=5e4+5;

struct Fenwick
{
    pair<int,double> tree[MAXN];
    int n;

    void init(int _n)
    {
        n=_n;
        fill(tree+1,tree+n+1,make_pair(0,0));
    }

    void update(int idx,int val,double num)
    {
        for(; idx<=n; idx+=idx&(-idx))
        {
            if(tree[idx].fi<val)
            {
                tree[idx].fi=val;
                tree[idx].se=num;
            }
            else if(tree[idx].fi==val) tree[idx].se+=num;
        }
    }

    void reset(int idx)
    {
        for(; idx<=n; idx+=idx&(-idx))
        {
            tree[idx]= {0,0};
        }
    }

    pair<int,double> query(int idx)
    {
        pair<int,double> ret= {0,0};
        for(; idx>0; idx-=idx&(-idx))
        {
            if(ret.fi<tree[idx].fi) ret=tree[idx];
            else if(ret.fi==tree[idx].fi) ret.se+=tree[idx].se;
        }
        return ret;
    }
};

struct Point
{
    int t,x,y;
};

int n;
Fenwick tree;
Point p[MAXN];
pair<int,double> dp[2][MAXN];
set<int> s;
unordered_map<int,int> code;

bool cmpT(Point a,Point b)
{
    return a.t<b.t;
}

bool RevCmpT(Point a,Point b)
{
    return a.t>b.t;
}

bool cmpX(Point a,Point b)
{
    return a.x>b.x;
}

bool RevCmpX(Point a,Point b)
{
    return a.x<b.x;
}

bool check(int x1,int x2,int fl)
{
    if(fl==0) return x1>=x2;
    else return x1<=x2;
}

void cdq(int l,int r,int fl)
{
    if(l>=r) return;

    if(fl==0) sort(p+l,p+r+1,cmpT);
    else sort(p+l,p+r+1,RevCmpT);

    int mid=(l+r)/2;
    cdq(l,mid,fl);

    if(fl==0)
    {
        sort(p+l,p+mid+1,cmpX);
        sort(p+mid+1,p+r+1,cmpX);
    }
    else
    {
        sort(p+l,p+mid+1,RevCmpX);
        sort(p+mid+1,p+r+1,RevCmpX);
    }
    int ptrL=l;
    for(int i=mid+1; i<=r; i++)
    {
        while(ptrL<=mid && check(p[ptrL].x,p[i].x,fl))
        {
            tree.update(p[ptrL].y, dp[fl][p[ptrL].t].fi, dp[fl][p[ptrL].t].se);
            ptrL++;
        }
        pair<int,double> cur=tree.query(p[i].y);
        if(dp[fl][p[i].t].fi<cur.fi+1) dp[fl][p[i].t]= {cur.fi+1, cur.se};
        else if(dp[fl][p[i].t].fi==cur.fi+1) dp[fl][p[i].t].se+=cur.se;
    }

    for(int i=l; i<ptrL; i++) tree.reset(p[i].y);

    cdq(mid+1,r,fl);
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin>>n;
    for(int i=1; i<=n; i++) p[i].t=i;
    for(int i=1; i<=n; i++)
    {
        cin>>p[i].x>>p[i].y;
        s.insert(p[i].y);
    }

    int ptr=0;
    for(auto it=s.begin(); it!=s.end(); it++) code[(*it)]=++ptr;
    for(int i=1; i<=n; i++) p[i].y=code[p[i].y];

    tree.init(n);
    for(int i=1; i<=n; i++) dp[0][i]=dp[1][i]= {1,(double)1};

    int maxy=0;
    for(int i=1; i<=n; i++) maxy=max(maxy, p[i].y);
    for(int i=1; i<=n; i++) p[i].y=maxy+1-p[i].y;
    cdq(1,n,0);
    sort(p+1,p+n+1,cmpT);
    for(int i=1; i<=n; i++) p[i].y=maxy+1-p[i].y;
    cdq(1,n,1);

    int ans=0;
    for(int i=1; i<=n; i++)
    {
        ans=max(ans, dp[0][i].fi);
    }
    cout<<ans<<endl;
    double cnt=0;
    for(int i=1; i<=n; i++)
    {
        if(dp[0][i].fi==ans) cnt+=dp[0][i].se;
    }
    for(int i=1; i<=n; i++)
    {
        if(dp[0][i].fi+dp[1][i].fi-1!=ans) cout<<0<<" ";
        else cout<<fixed<<setprecision(10)<<dp[0][i].se*dp[1][i].se/cnt<<" ";
    }
    cout<<endl;

    return 0;
}
