#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN=1e5+5;

struct Fenwick
{
    int tree[MAXN];
    int n;

    void init(int _n)
    {
        n=_n;
        fill(tree+1,tree+n+1,0);
    }

    void update(int idx,int val)
    {
        for(; idx<=n; idx+=idx&(-idx))
        {
            tree[idx]=max(tree[idx], val);
        }
    }

    void reset(int idx)
    {
        for(; idx<=n; idx+=idx&(-idx))
        {
            tree[idx]=0;
        }
    }

    int query(int idx)
    {
        int ret=0;
        for(; idx>0; idx-=idx&(-idx))
        {
            ret=max(ret, tree[idx]);
        }
        return ret;
    }
};

struct Point
{
    int t,x,y;
};

int n;
Fenwick tree;
Point p[MAXN];
int dp[MAXN];

bool cmpT(Point a,Point b)
{
    return a.t<b.t;
}

bool cmpX(Point a,Point b)
{
    return a.x<b.x;
}

void cdq(int l,int r)
{
    if(l>=r) return;

    sort(p+l,p+r+1,cmpT);

    int mid=(l+r)/2;
    cdq(l,mid);

    sort(p+l,p+mid+1,cmpX);
    sort(p+mid+1,p+r+1,cmpX);
    int ptrL=l;
    for(int i=mid+1; i<=r; i++)
    {
        while(ptrL<=mid && p[ptrL].x<p[i].x)
        {
            tree.update(p[ptrL].y, dp[p[ptrL].t]);
            ptrL++;
        }
        dp[p[i].t]=max(dp[p[i].t], tree.query(p[i].y-1)+1);
    }

    for(int i=l; i<ptrL; i++) tree.reset(p[i].y);

    cdq(mid+1,r);
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin>>n;
    for(int i=1; i<=n; i++) p[i].t=i;
    for(int i=1; i<=n; i++)
    {
        int ind;
        cin>>ind;
        p[ind].x=i;
    }
    for(int i=1; i<=n; i++)
    {
        int ind;
        cin>>ind;
        p[ind].y=i;
    }

    tree.init(n);
    for(int i=1; i<=n; i++) dp[i]=1;

    cdq(1,n);

    int ans=0;
    for(int i=1; i<=n; i++) ans=max(ans, dp[i]);
    cout<<ans<<endl;

    return 0;
}
